<?php

namespace ApptitudeNamespace;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'storeFullCustomerSet' => '\\ApptitudeNamespace\\StructType\\StoreFullCustomerSet',
            'xCustomer30' => '\\ApptitudeNamespace\\StructType\\XCustomer30',
            'xObject30' => '\\ApptitudeNamespace\\StructType\\XObject30',
            'xLocation30' => '\\ApptitudeNamespace\\StructType\\XLocation30',
            'xContact30' => '\\ApptitudeNamespace\\StructType\\XContact30',
            'xMarginGroup30' => '\\ApptitudeNamespace\\StructType\\XMarginGroup30',
            'xDiscountGroup30' => '\\ApptitudeNamespace\\StructType\\XDiscountGroup30',
            'xBudgetComponent30' => '\\ApptitudeNamespace\\StructType\\XBudgetComponent30',
            'xAgreement30' => '\\ApptitudeNamespace\\StructType\\XAgreement30',
            'xCustomChoice30' => '\\ApptitudeNamespace\\StructType\\XCustomChoice30',
            'xOrderAmountModificationRule30' => '\\ApptitudeNamespace\\StructType\\XOrderAmountModificationRule30',
            'xExtraField30' => '\\ApptitudeNamespace\\StructType\\XExtraField30',
            'storeFullCustomerSetResponse' => '\\ApptitudeNamespace\\StructType\\StoreFullCustomerSetResponse',
            'storeFullProductAccessSet' => '\\ApptitudeNamespace\\StructType\\StoreFullProductAccessSet',
            'xProductAccessRule30' => '\\ApptitudeNamespace\\StructType\\XProductAccessRule30',
            'storeFullProductAccessSetResponse' => '\\ApptitudeNamespace\\StructType\\StoreFullProductAccessSetResponse',
            'storeFullCustomerAccessSetForAgent' => '\\ApptitudeNamespace\\StructType\\StoreFullCustomerAccessSetForAgent',
            'xCustomerAccessRecord30' => '\\ApptitudeNamespace\\StructType\\XCustomerAccessRecord30',
            'storeFullCustomerAccessSetForAgentResponse' => '\\ApptitudeNamespace\\StructType\\StoreFullCustomerAccessSetForAgentResponse',
            'storeHistoricalOrders' => '\\ApptitudeNamespace\\StructType\\StoreHistoricalOrders',
            'xHistoricalOrder30' => '\\ApptitudeNamespace\\StructType\\XHistoricalOrder30',
            'xHistoricalOrderLine30' => '\\ApptitudeNamespace\\StructType\\XHistoricalOrderLine30',
            'storeHistoricalOrdersResponse' => '\\ApptitudeNamespace\\StructType\\StoreHistoricalOrdersResponse',
            'storeFullHistoricalOrderSetForCustomer' => '\\ApptitudeNamespace\\StructType\\StoreFullHistoricalOrderSetForCustomer',
            'storeFullHistoricalOrderSetForCustomerResponse' => '\\ApptitudeNamespace\\StructType\\StoreFullHistoricalOrderSetForCustomerResponse',
            'updatePrices' => '\\ApptitudeNamespace\\StructType\\UpdatePrices',
            'xPriceInfoElement30' => '\\ApptitudeNamespace\\StructType\\XPriceInfoElement30',
            'updatePricesResponse' => '\\ApptitudeNamespace\\StructType\\UpdatePricesResponse',
            'deleteCustomers' => '\\ApptitudeNamespace\\StructType\\DeleteCustomers',
            'deleteCustomersResponse' => '\\ApptitudeNamespace\\StructType\\DeleteCustomersResponse',
            'storeFullCustomerAccessSet' => '\\ApptitudeNamespace\\StructType\\StoreFullCustomerAccessSet',
            'xAgentCustomerAccess30' => '\\ApptitudeNamespace\\StructType\\XAgentCustomerAccess30',
            'storeFullCustomerAccessSetResponse' => '\\ApptitudeNamespace\\StructType\\StoreFullCustomerAccessSetResponse',
            'markOrdersAsProcessed' => '\\ApptitudeNamespace\\StructType\\MarkOrdersAsProcessed',
            'markOrdersAsProcessedResponse' => '\\ApptitudeNamespace\\StructType\\MarkOrdersAsProcessedResponse',
            'deleteAllHistoricalOrders' => '\\ApptitudeNamespace\\StructType\\DeleteAllHistoricalOrders',
            'deleteAllHistoricalOrdersResponse' => '\\ApptitudeNamespace\\StructType\\DeleteAllHistoricalOrdersResponse',
            'deleteAllProductAccessRules' => '\\ApptitudeNamespace\\StructType\\DeleteAllProductAccessRules',
            'deleteAllProductAccessRulesResponse' => '\\ApptitudeNamespace\\StructType\\DeleteAllProductAccessRulesResponse',
            'storeProducts' => '\\ApptitudeNamespace\\StructType\\StoreProducts',
            'xProduct30' => '\\ApptitudeNamespace\\StructType\\XProduct30',
            'xMinimumQuantity30' => '\\ApptitudeNamespace\\StructType\\XMinimumQuantity30',
            'xPrice30' => '\\ApptitudeNamespace\\StructType\\XPrice30',
            'xSize30' => '\\ApptitudeNamespace\\StructType\\XSize30',
            'xPrepackContentElement30' => '\\ApptitudeNamespace\\StructType\\XPrepackContentElement30',
            'xStockLevel30' => '\\ApptitudeNamespace\\StructType\\XStockLevel30',
            'xMedium30' => '\\ApptitudeNamespace\\StructType\\XMedium30',
            'xDeliveryWindow30' => '\\ApptitudeNamespace\\StructType\\XDeliveryWindow30',
            'storeProductsResponse' => '\\ApptitudeNamespace\\StructType\\StoreProductsResponse',
            'storeProductAccessRules' => '\\ApptitudeNamespace\\StructType\\StoreProductAccessRules',
            'storeProductAccessRulesResponse' => '\\ApptitudeNamespace\\StructType\\StoreProductAccessRulesResponse',
            'deleteAllInvoices' => '\\ApptitudeNamespace\\StructType\\DeleteAllInvoices',
            'deleteAllInvoicesResponse' => '\\ApptitudeNamespace\\StructType\\DeleteAllInvoicesResponse',
            'getOrders' => '\\ApptitudeNamespace\\StructType\\GetOrders',
            'getOrdersResponse' => '\\ApptitudeNamespace\\StructType\\GetOrdersResponse',
            'xOrder30' => '\\ApptitudeNamespace\\StructType\\XOrder30',
            'xOrderLine30' => '\\ApptitudeNamespace\\StructType\\XOrderLine30',
            'xOrderConfirmation30' => '\\ApptitudeNamespace\\StructType\\XOrderConfirmation30',
            'storeCustomers' => '\\ApptitudeNamespace\\StructType\\StoreCustomers',
            'storeCustomersResponse' => '\\ApptitudeNamespace\\StructType\\StoreCustomersResponse',
            'getUnprocessedOrders' => '\\ApptitudeNamespace\\StructType\\GetUnprocessedOrders',
            'getUnprocessedOrdersResponse' => '\\ApptitudeNamespace\\StructType\\GetUnprocessedOrdersResponse',
            'deleteProductAccessRules' => '\\ApptitudeNamespace\\StructType\\DeleteProductAccessRules',
            'deleteProductAccessRulesResponse' => '\\ApptitudeNamespace\\StructType\\DeleteProductAccessRulesResponse',
            'updateStock' => '\\ApptitudeNamespace\\StructType\\UpdateStock',
            'xStockInfoElement30' => '\\ApptitudeNamespace\\StructType\\XStockInfoElement30',
            'updateStockResponse' => '\\ApptitudeNamespace\\StructType\\UpdateStockResponse',
            'deleteAllProducts' => '\\ApptitudeNamespace\\StructType\\DeleteAllProducts',
            'deleteAllProductsResponse' => '\\ApptitudeNamespace\\StructType\\DeleteAllProductsResponse',
            'storeFullInvoiceSetForCustomer' => '\\ApptitudeNamespace\\StructType\\StoreFullInvoiceSetForCustomer',
            'xInvoice30' => '\\ApptitudeNamespace\\StructType\\XInvoice30',
            'storeFullInvoiceSetForCustomerResponse' => '\\ApptitudeNamespace\\StructType\\StoreFullInvoiceSetForCustomerResponse',
            'deleteInvoices' => '\\ApptitudeNamespace\\StructType\\DeleteInvoices',
            'deleteInvoicesResponse' => '\\ApptitudeNamespace\\StructType\\DeleteInvoicesResponse',
            'getInfo' => '\\ApptitudeNamespace\\StructType\\GetInfo',
            'getInfoResponse' => '\\ApptitudeNamespace\\StructType\\GetInfoResponse',
            'deleteAllCustomers' => '\\ApptitudeNamespace\\StructType\\DeleteAllCustomers',
            'deleteAllCustomersResponse' => '\\ApptitudeNamespace\\StructType\\DeleteAllCustomersResponse',
            'deleteProducts' => '\\ApptitudeNamespace\\StructType\\DeleteProducts',
            'deleteProductsResponse' => '\\ApptitudeNamespace\\StructType\\DeleteProductsResponse',
            'storeInvoices' => '\\ApptitudeNamespace\\StructType\\StoreInvoices',
            'storeInvoicesResponse' => '\\ApptitudeNamespace\\StructType\\StoreInvoicesResponse',
            'deleteHistoricalOrders' => '\\ApptitudeNamespace\\StructType\\DeleteHistoricalOrders',
            'deleteHistoricalOrdersResponse' => '\\ApptitudeNamespace\\StructType\\DeleteHistoricalOrdersResponse',
            'deleteProductAccessRulesForCustomer' => '\\ApptitudeNamespace\\StructType\\DeleteProductAccessRulesForCustomer',
            'deleteProductAccessRulesForCustomerResponse' => '\\ApptitudeNamespace\\StructType\\DeleteProductAccessRulesForCustomerResponse',
            'storeFullProductSet' => '\\ApptitudeNamespace\\StructType\\StoreFullProductSet',
            'storeFullProductSetResponse' => '\\ApptitudeNamespace\\StructType\\StoreFullProductSetResponse',
            'getAllProducts' => '\\ApptitudeNamespace\\StructType\\GetAllProducts',
            'getAllProductsResponse' => '\\ApptitudeNamespace\\StructType\\GetAllProductsResponse',
        );
    }
}
