<?php

namespace ApptitudeNamespace\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for xLocation30 StructType
 * @subpackage Structs
 */
class XLocation30 extends XObject30
{
    /**
     * The defaultLocation
     * @var bool
     */
    public $defaultLocation;
    /**
     * The code
     * @var string
     */
    public $code;
    /**
     * The name
     * @var string
     */
    public $name;
    /**
     * The address
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $address;
    /**
     * The street
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $street;
    /**
     * The houseNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $houseNumber;
    /**
     * The houseNumberSuffix
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $houseNumberSuffix;
    /**
     * The postalCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $postalCode;
    /**
     * The city
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $city;
    /**
     * The country
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $country;
    /**
     * The email
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $email;
    /**
     * The telephone
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $telephone;
    /**
     * The contactFirstName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $contactFirstName;
    /**
     * The contactLastName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $contactLastName;
    /**
     * The contactTelephone
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $contactTelephone;
    /**
     * Constructor method for xLocation30
     * @uses XLocation30::setDefaultLocation()
     * @uses XLocation30::setCode()
     * @uses XLocation30::setName()
     * @uses XLocation30::setAddress()
     * @uses XLocation30::setStreet()
     * @uses XLocation30::setHouseNumber()
     * @uses XLocation30::setHouseNumberSuffix()
     * @uses XLocation30::setPostalCode()
     * @uses XLocation30::setCity()
     * @uses XLocation30::setCountry()
     * @uses XLocation30::setEmail()
     * @uses XLocation30::setTelephone()
     * @uses XLocation30::setContactFirstName()
     * @uses XLocation30::setContactLastName()
     * @uses XLocation30::setContactTelephone()
     * @param bool $defaultLocation
     * @param string $code
     * @param string $name
     * @param string $address
     * @param string $street
     * @param string $houseNumber
     * @param string $houseNumberSuffix
     * @param string $postalCode
     * @param string $city
     * @param string $country
     * @param string $email
     * @param string $telephone
     * @param string $contactFirstName
     * @param string $contactLastName
     * @param string $contactTelephone
     */
    public function __construct($defaultLocation = null, $code = null, $name = null, $address = null, $street = null, $houseNumber = null, $houseNumberSuffix = null, $postalCode = null, $city = null, $country = null, $email = null, $telephone = null, $contactFirstName = null, $contactLastName = null, $contactTelephone = null)
    {
        $this
            ->setDefaultLocation($defaultLocation)
            ->setCode($code)
            ->setName($name)
            ->setAddress($address)
            ->setStreet($street)
            ->setHouseNumber($houseNumber)
            ->setHouseNumberSuffix($houseNumberSuffix)
            ->setPostalCode($postalCode)
            ->setCity($city)
            ->setCountry($country)
            ->setEmail($email)
            ->setTelephone($telephone)
            ->setContactFirstName($contactFirstName)
            ->setContactLastName($contactLastName)
            ->setContactTelephone($contactTelephone);
    }
    /**
     * Get defaultLocation value
     * @return bool|null
     */
    public function getDefaultLocation()
    {
        return $this->defaultLocation;
    }
    /**
     * Set defaultLocation value
     * @param bool $defaultLocation
     * @return \ApptitudeNamespace\StructType\XLocation30
     */
    public function setDefaultLocation($defaultLocation = null)
    {
        // validation for constraint: boolean
        if (!is_null($defaultLocation) && !is_bool($defaultLocation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($defaultLocation)), __LINE__);
        }
        $this->defaultLocation = $defaultLocation;
        return $this;
    }
    /**
     * Get code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->code;
    }
    /**
     * Set code value
     * @param string $code
     * @return \ApptitudeNamespace\StructType\XLocation30
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($code)), __LINE__);
        }
        $this->code = $code;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \ApptitudeNamespace\StructType\XLocation30
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get address value
     * @return string|null
     */
    public function getAddress()
    {
        return $this->address;
    }
    /**
     * Set address value
     * @param string $address
     * @return \ApptitudeNamespace\StructType\XLocation30
     */
    public function setAddress($address = null)
    {
        // validation for constraint: string
        if (!is_null($address) && !is_string($address)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($address)), __LINE__);
        }
        $this->address = $address;
        return $this;
    }
    /**
     * Get street value
     * @return string|null
     */
    public function getStreet()
    {
        return $this->street;
    }
    /**
     * Set street value
     * @param string $street
     * @return \ApptitudeNamespace\StructType\XLocation30
     */
    public function setStreet($street = null)
    {
        // validation for constraint: string
        if (!is_null($street) && !is_string($street)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($street)), __LINE__);
        }
        $this->street = $street;
        return $this;
    }
    /**
     * Get houseNumber value
     * @return string|null
     */
    public function getHouseNumber()
    {
        return $this->houseNumber;
    }
    /**
     * Set houseNumber value
     * @param string $houseNumber
     * @return \ApptitudeNamespace\StructType\XLocation30
     */
    public function setHouseNumber($houseNumber = null)
    {
        // validation for constraint: string
        if (!is_null($houseNumber) && !is_string($houseNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($houseNumber)), __LINE__);
        }
        $this->houseNumber = $houseNumber;
        return $this;
    }
    /**
     * Get houseNumberSuffix value
     * @return string|null
     */
    public function getHouseNumberSuffix()
    {
        return $this->houseNumberSuffix;
    }
    /**
     * Set houseNumberSuffix value
     * @param string $houseNumberSuffix
     * @return \ApptitudeNamespace\StructType\XLocation30
     */
    public function setHouseNumberSuffix($houseNumberSuffix = null)
    {
        // validation for constraint: string
        if (!is_null($houseNumberSuffix) && !is_string($houseNumberSuffix)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($houseNumberSuffix)), __LINE__);
        }
        $this->houseNumberSuffix = $houseNumberSuffix;
        return $this;
    }
    /**
     * Get postalCode value
     * @return string|null
     */
    public function getPostalCode()
    {
        return $this->postalCode;
    }
    /**
     * Set postalCode value
     * @param string $postalCode
     * @return \ApptitudeNamespace\StructType\XLocation30
     */
    public function setPostalCode($postalCode = null)
    {
        // validation for constraint: string
        if (!is_null($postalCode) && !is_string($postalCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($postalCode)), __LINE__);
        }
        $this->postalCode = $postalCode;
        return $this;
    }
    /**
     * Get city value
     * @return string|null
     */
    public function getCity()
    {
        return $this->city;
    }
    /**
     * Set city value
     * @param string $city
     * @return \ApptitudeNamespace\StructType\XLocation30
     */
    public function setCity($city = null)
    {
        // validation for constraint: string
        if (!is_null($city) && !is_string($city)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($city)), __LINE__);
        }
        $this->city = $city;
        return $this;
    }
    /**
     * Get country value
     * @return string|null
     */
    public function getCountry()
    {
        return $this->country;
    }
    /**
     * Set country value
     * @param string $country
     * @return \ApptitudeNamespace\StructType\XLocation30
     */
    public function setCountry($country = null)
    {
        // validation for constraint: string
        if (!is_null($country) && !is_string($country)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($country)), __LINE__);
        }
        $this->country = $country;
        return $this;
    }
    /**
     * Get email value
     * @return string|null
     */
    public function getEmail()
    {
        return $this->email;
    }
    /**
     * Set email value
     * @param string $email
     * @return \ApptitudeNamespace\StructType\XLocation30
     */
    public function setEmail($email = null)
    {
        // validation for constraint: string
        if (!is_null($email) && !is_string($email)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($email)), __LINE__);
        }
        $this->email = $email;
        return $this;
    }
    /**
     * Get telephone value
     * @return string|null
     */
    public function getTelephone()
    {
        return $this->telephone;
    }
    /**
     * Set telephone value
     * @param string $telephone
     * @return \ApptitudeNamespace\StructType\XLocation30
     */
    public function setTelephone($telephone = null)
    {
        // validation for constraint: string
        if (!is_null($telephone) && !is_string($telephone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($telephone)), __LINE__);
        }
        $this->telephone = $telephone;
        return $this;
    }
    /**
     * Get contactFirstName value
     * @return string|null
     */
    public function getContactFirstName()
    {
        return $this->contactFirstName;
    }
    /**
     * Set contactFirstName value
     * @param string $contactFirstName
     * @return \ApptitudeNamespace\StructType\XLocation30
     */
    public function setContactFirstName($contactFirstName = null)
    {
        // validation for constraint: string
        if (!is_null($contactFirstName) && !is_string($contactFirstName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($contactFirstName)), __LINE__);
        }
        $this->contactFirstName = $contactFirstName;
        return $this;
    }
    /**
     * Get contactLastName value
     * @return string|null
     */
    public function getContactLastName()
    {
        return $this->contactLastName;
    }
    /**
     * Set contactLastName value
     * @param string $contactLastName
     * @return \ApptitudeNamespace\StructType\XLocation30
     */
    public function setContactLastName($contactLastName = null)
    {
        // validation for constraint: string
        if (!is_null($contactLastName) && !is_string($contactLastName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($contactLastName)), __LINE__);
        }
        $this->contactLastName = $contactLastName;
        return $this;
    }
    /**
     * Get contactTelephone value
     * @return string|null
     */
    public function getContactTelephone()
    {
        return $this->contactTelephone;
    }
    /**
     * Set contactTelephone value
     * @param string $contactTelephone
     * @return \ApptitudeNamespace\StructType\XLocation30
     */
    public function setContactTelephone($contactTelephone = null)
    {
        // validation for constraint: string
        if (!is_null($contactTelephone) && !is_string($contactTelephone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($contactTelephone)), __LINE__);
        }
        $this->contactTelephone = $contactTelephone;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \ApptitudeNamespace\StructType\XLocation30
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
