<?php

namespace ApptitudeNamespace\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for xProductAccessRule30 StructType
 * @subpackage Structs
 */
class XProductAccessRule30 extends XObject30
{
    /**
     * The customerNo
     * @var string
     */
    public $customerNo;
    /**
     * The type
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $type;
    /**
     * The uniqueId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $uniqueId;
    /**
     * The colorCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $colorCode;
    /**
     * The categoryCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $categoryCode;
    /**
     * The productGroupCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $productGroupCode;
    /**
     * The brandId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $brandId;
    /**
     * The sortCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $sortCode;
    /**
     * Constructor method for xProductAccessRule30
     * @uses XProductAccessRule30::setCustomerNo()
     * @uses XProductAccessRule30::setType()
     * @uses XProductAccessRule30::setUniqueId()
     * @uses XProductAccessRule30::setColorCode()
     * @uses XProductAccessRule30::setCategoryCode()
     * @uses XProductAccessRule30::setProductGroupCode()
     * @uses XProductAccessRule30::setBrandId()
     * @uses XProductAccessRule30::setSortCode()
     * @param string $customerNo
     * @param string $type
     * @param string $uniqueId
     * @param string $colorCode
     * @param string $categoryCode
     * @param string $productGroupCode
     * @param string $brandId
     * @param int $sortCode
     */
    public function __construct($customerNo = null, $type = null, $uniqueId = null, $colorCode = null, $categoryCode = null, $productGroupCode = null, $brandId = null, $sortCode = null)
    {
        $this
            ->setCustomerNo($customerNo)
            ->setType($type)
            ->setUniqueId($uniqueId)
            ->setColorCode($colorCode)
            ->setCategoryCode($categoryCode)
            ->setProductGroupCode($productGroupCode)
            ->setBrandId($brandId)
            ->setSortCode($sortCode);
    }
    /**
     * Get customerNo value
     * @return string|null
     */
    public function getCustomerNo()
    {
        return $this->customerNo;
    }
    /**
     * Set customerNo value
     * @param string $customerNo
     * @return \ApptitudeNamespace\StructType\XProductAccessRule30
     */
    public function setCustomerNo($customerNo = null)
    {
        // validation for constraint: string
        if (!is_null($customerNo) && !is_string($customerNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($customerNo)), __LINE__);
        }
        $this->customerNo = $customerNo;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @uses \ApptitudeNamespace\EnumType\XProductAccessRuleType30::valueIsValid()
     * @uses \ApptitudeNamespace\EnumType\XProductAccessRuleType30::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return \ApptitudeNamespace\StructType\XProductAccessRule30
     */
    public function setType($type = null)
    {
        // validation for constraint: enumeration
        if (!\ApptitudeNamespace\EnumType\XProductAccessRuleType30::valueIsValid($type)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $type, implode(', ', \ApptitudeNamespace\EnumType\XProductAccessRuleType30::getValidValues())), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get uniqueId value
     * @return string|null
     */
    public function getUniqueId()
    {
        return $this->uniqueId;
    }
    /**
     * Set uniqueId value
     * @param string $uniqueId
     * @return \ApptitudeNamespace\StructType\XProductAccessRule30
     */
    public function setUniqueId($uniqueId = null)
    {
        // validation for constraint: string
        if (!is_null($uniqueId) && !is_string($uniqueId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($uniqueId)), __LINE__);
        }
        $this->uniqueId = $uniqueId;
        return $this;
    }
    /**
     * Get colorCode value
     * @return string|null
     */
    public function getColorCode()
    {
        return $this->colorCode;
    }
    /**
     * Set colorCode value
     * @param string $colorCode
     * @return \ApptitudeNamespace\StructType\XProductAccessRule30
     */
    public function setColorCode($colorCode = null)
    {
        // validation for constraint: string
        if (!is_null($colorCode) && !is_string($colorCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($colorCode)), __LINE__);
        }
        $this->colorCode = $colorCode;
        return $this;
    }
    /**
     * Get categoryCode value
     * @return string|null
     */
    public function getCategoryCode()
    {
        return $this->categoryCode;
    }
    /**
     * Set categoryCode value
     * @param string $categoryCode
     * @return \ApptitudeNamespace\StructType\XProductAccessRule30
     */
    public function setCategoryCode($categoryCode = null)
    {
        // validation for constraint: string
        if (!is_null($categoryCode) && !is_string($categoryCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($categoryCode)), __LINE__);
        }
        $this->categoryCode = $categoryCode;
        return $this;
    }
    /**
     * Get productGroupCode value
     * @return string|null
     */
    public function getProductGroupCode()
    {
        return $this->productGroupCode;
    }
    /**
     * Set productGroupCode value
     * @param string $productGroupCode
     * @return \ApptitudeNamespace\StructType\XProductAccessRule30
     */
    public function setProductGroupCode($productGroupCode = null)
    {
        // validation for constraint: string
        if (!is_null($productGroupCode) && !is_string($productGroupCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($productGroupCode)), __LINE__);
        }
        $this->productGroupCode = $productGroupCode;
        return $this;
    }
    /**
     * Get brandId value
     * @return string|null
     */
    public function getBrandId()
    {
        return $this->brandId;
    }
    /**
     * Set brandId value
     * @param string $brandId
     * @return \ApptitudeNamespace\StructType\XProductAccessRule30
     */
    public function setBrandId($brandId = null)
    {
        // validation for constraint: string
        if (!is_null($brandId) && !is_string($brandId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($brandId)), __LINE__);
        }
        $this->brandId = $brandId;
        return $this;
    }
    /**
     * Get sortCode value
     * @return int|null
     */
    public function getSortCode()
    {
        return $this->sortCode;
    }
    /**
     * Set sortCode value
     * @param int $sortCode
     * @return \ApptitudeNamespace\StructType\XProductAccessRule30
     */
    public function setSortCode($sortCode = null)
    {
        // validation for constraint: int
        if (!is_null($sortCode) && !is_numeric($sortCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($sortCode)), __LINE__);
        }
        $this->sortCode = $sortCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \ApptitudeNamespace\StructType\XProductAccessRule30
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
