<?php

namespace ApptitudeNamespace\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for xStockLevel30 StructType
 * @subpackage Structs
 */
class XStockLevel30 extends XObject30
{
    /**
     * The startDate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $startDate;
    /**
     * The quantity
     * @var int
     */
    public $quantity;
    /**
     * The customField
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $customField;
    /**
     * Constructor method for xStockLevel30
     * @uses XStockLevel30::setStartDate()
     * @uses XStockLevel30::setQuantity()
     * @uses XStockLevel30::setCustomField()
     * @param string $startDate
     * @param int $quantity
     * @param string $customField
     */
    public function __construct($startDate = null, $quantity = null, $customField = null)
    {
        $this
            ->setStartDate($startDate)
            ->setQuantity($quantity)
            ->setCustomField($customField);
    }
    /**
     * Get startDate value
     * @return string|null
     */
    public function getStartDate()
    {
        return $this->startDate;
    }
    /**
     * Set startDate value
     * @param string $startDate
     * @return \ApptitudeNamespace\StructType\XStockLevel30
     */
    public function setStartDate($startDate = null)
    {
        // validation for constraint: string
        if (!is_null($startDate) && !is_string($startDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($startDate)), __LINE__);
        }
        $this->startDate = $startDate;
        return $this;
    }
    /**
     * Get quantity value
     * @return int|null
     */
    public function getQuantity()
    {
        return $this->quantity;
    }
    /**
     * Set quantity value
     * @param int $quantity
     * @return \ApptitudeNamespace\StructType\XStockLevel30
     */
    public function setQuantity($quantity = null)
    {
        // validation for constraint: int
        if (!is_null($quantity) && !is_numeric($quantity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($quantity)), __LINE__);
        }
        $this->quantity = $quantity;
        return $this;
    }
    /**
     * Get customField value
     * @return string|null
     */
    public function getCustomField()
    {
        return $this->customField;
    }
    /**
     * Set customField value
     * @param string $customField
     * @return \ApptitudeNamespace\StructType\XStockLevel30
     */
    public function setCustomField($customField = null)
    {
        // validation for constraint: string
        if (!is_null($customField) && !is_string($customField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($customField)), __LINE__);
        }
        $this->customField = $customField;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \ApptitudeNamespace\StructType\XStockLevel30
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
